package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.UserRoleDataAction;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleDataActionSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<UserRoleDataAction> selectCond;
	private JSONObject customsearchval;
	public UserRoleDataActionSearchFilter(){
		this.page =new Page<UserRoleDataAction>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<UserRoleDataAction>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_userroledataactionname_like;

	public void setN_userroledataactionname_like(String n_userroledataactionname_like) {
        this.n_userroledataactionname_like = n_userroledataactionname_like;
        if(!StringUtils.isEmpty(this.n_userroledataactionname_like)){
            this.selectCond.like("userroledataactionname", n_userroledataactionname_like);
        }
    }
	private String n_userroledataid_eq;

	public void setN_userroledataid_eq(String n_userroledataid_eq) {
        this.n_userroledataid_eq = n_userroledataid_eq;
        if(!StringUtils.isEmpty(this.n_userroledataid_eq)){
            this.selectCond.eq("userroledataid", n_userroledataid_eq);
        }
    }
	private String n_userroledataname_eq;

	public void setN_userroledataname_eq(String n_userroledataname_eq) {
        this.n_userroledataname_eq = n_userroledataname_eq;
        if(!StringUtils.isEmpty(this.n_userroledataname_eq)){
            this.selectCond.eq("userroledataname", n_userroledataname_eq);
        }
    }
	private String n_userroledataname_like;

	public void setN_userroledataname_like(String n_userroledataname_like) {
        this.n_userroledataname_like = n_userroledataname_like;
        if(!StringUtils.isEmpty(this.n_userroledataname_like)){
            this.selectCond.like("userroledataname", n_userroledataname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLEDATAACTION_USERROLEDATA_USERROLEDATAID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_userroledataid_eq("NA");
			}
			else{
				this.setN_userroledataid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("userroledataactionname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}